package rmrs.persist;

/*
 * Copyright (c) 1999 The Regenstrief Institute.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Written by Gunther Schadow.
 *
 * $Id: SQLInsert.java,v 1.1 1999/12/06 19:25:44 schadow Exp $
 */

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

/** Helps formulate an insert operation in SQL.
 *
 * @author Gunther Schadow
 * @version $Id: SQLInsert.java,v 1.1 1999/12/06 19:25:44 schadow Exp $ 
 */
class SQLInsert 
    extends SQLStatement
{
    boolean first = true;

    public SQLInsert(String table) {
	super("INSERT INTO ");
	buf.append(table);
	buf.append(" (");
    }

    public void addField(String name, Object value) {
	// System.out.println(name + "=" + value);

	if(first)
	    first = false;
	else
	    buf.append(", ");

	buf.append(name);
	args.addElement(value);
    }
    
    public void execute(Connection con) 
	throws SQLException
    {
	buf.append(") VALUES (?");
	int max = args.size();
	for(int i = 1; i < max; i++)
	    buf.append(", ?");
	buf.append(");");

	super.execute(con);
	statement.executeUpdate();
    }
}
