package rmrs.persist;

/*
 * Copyright (c) 1999 The Regenstrief Institute.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Written by Gunther Schadow.
 *
 * $Id: SQLUpdate.java,v 1.1 1999/12/06 19:25:44 schadow Exp $
 */

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

/** A somewhat computationally useful way to formulate an update
 * statement in SQL, urgh!
 *
 * @author Gunther Schadow
 * @version $Id: SQLUpdate.java,v 1.1 1999/12/06 19:25:44 schadow Exp $ 
 */
class SQLUpdate
    extends SQLStatement
{
    boolean first = true;
    String keyName  = null;
    Object keyValue = null;

    public SQLUpdate(String table) {
	super("UPDATE ");
	buf.append(table);
	buf.append(" SET ");
    }

    public void addField(String name, Object value) {
	if(first)
	    first = false;
	else
	    buf.append(", ");

	buf.append(name);
	buf.append("=?");

	args.addElement(value);
    }

    public void addKey(String name, Object value) {
	if(keyName == null) {
	    keyName  = name;
	    keyValue = value;
	} else
	    throw new Error("key field set twice!");
    }

    public void execute(Connection con) 
	throws SQLException
    {
	buf.append(" WHERE ");
	buf.append(keyName);
	buf.append("=?;");
	args.addElement(keyValue);	
	
	super.execute(con);
	statement.executeUpdate();
    }
}







